// gcc -Wall -Wpedantic -Wextra -std=c17 -march=haswell -O3 running-time.c
#define _POSIX_C_SOURCE 199309L
#include <time.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <x86intrin.h>

int64_t calculate_something(void) {
    int64_t result = 0;
    for (int64_t i = 0; i < 100000000; i++) {
        result += rand() % 10 - 4;
    }
    return result;
}

void time_rdtsc() {
    int64_t result;
    unsigned start = __rdtsc();
    result = calculate_something();
    unsigned end = __rdtsc();
    unsigned elapsed = end - start;
    printf("Calculated %ld in %u cycles.\n", result, elapsed);
}

void time_gettime() {
    int64_t result;
    struct timespec start, end;
    clock_gettime(CLOCK_PROCESS_CPUTIME_ID, &start);
    result = calculate_something();
    clock_gettime(CLOCK_PROCESS_CPUTIME_ID, &end);
    double elapsed = (end.tv_sec - start.tv_sec)
                     + (end.tv_nsec - start.tv_nsec) / 1e9;
    printf("Calculated %ld in %g s.\n", result, elapsed);
}

int main(void) {
    srand(0);
    time_rdtsc();
    srand(0);
    time_gettime();
    srand(0);
    time_rdtsc();
    srand(0);
    time_gettime();
    return 0;
}

